/* here you should define the FULL path of the modmap files....*/
#define STANDARD_XMODMAP_FILE "/root/keys/normal"
#define GREEK_XMODMAP_FILE "/root/keys/grkfull"
#define BOTH_XMODMAP_FILE "/root/keys/both"

#include <stdio.h>
#include "/usr/X11R6/include/X11/Xlib.h"

static Display *display;
static Window window;
static GC gc;
static int screen;
static Colormap cmap;
static XSetWindowAttributes attr;
static XEvent event;
static XColor color;
int Width,Height,depth,white;

void connecttoserver(char *name_of_display)
{
  int f;
  
  if ( (display = XOpenDisplay(name_of_display)) == NULL )
    {
      (void) fprintf(stderr, " cannot connect to X server %s\n", XDisplayName(name_of_display));
      exit(-1);
    }


  screen=DefaultScreen(display);
  depth=DisplayPlanes(display,screen);
  cmap=DefaultColormap(display,screen);
  window=XCreateWindow(display,RootWindow(display,screen),
		       0,0,70,60,0,depth,InputOutput,
		       XDefaultVisual(display,screen),
		       CWColormap,&attr);
  XSetStandardProperties(display,window,"KEYBOARD","keyboard swapper",None,0,0,0);
  gc=XCreateGC(display,window,0,0);
  XSetWindowBackground(display,window,BlackPixel(display,screen));
  XSetBackground (display,gc,BlackPixel(display,screen));
  XSetForeground (display,gc,WhitePixel(display,screen));
  XClearWindow(display,window);
  XMapRaised(display,window);
  XSelectInput(display,window, KeyPressMask | ExposureMask | ButtonPressMask );
}

void disconnect()
{
  XFreeGC(display, gc);
  XDestroyWindow(display, window);
  XCloseDisplay(display);
}


void load_modmap(char *modmap_path)
{
  int pid, status;


  pid = fork();

  if (pid <0) {
    perror("fork");
    exit(1);
  }
  else if (pid == 0) {    
    execlp("xmodmap", "xmodmap", modmap_path, (char *) 0);
    perror("execlp"); 
    exit(1);
  }
  else {                  
    wait(&status);
     
  }
  
}



main()
{
  char *s = "1";
  char *name_of_display = NULL;
  XEvent event;
  XKeyEvent key_event;

  connecttoserver(name_of_display);

  while (1)
   {
     XNextEvent(display,&event);
     switch(event.type)
       {
       case KeyPress:
	 if (event.xkey.keycode == 9)
	   {
	     load_modmap(STANDARD_XMODMAP_FILE);
	     disconnect();
	     return 4;
	   }
	 else if (event.xkey.keycode == 12)
	   {
	     s = "3";

	     load_modmap(GREEK_XMODMAP_FILE);
	     XDrawImageString(display,window,gc,50,58,s,1);
	   }
	 else if (event.xkey.keycode == 11)
	   {
	     s = "2";

	     load_modmap(BOTH_XMODMAP_FILE);
	     XDrawImageString(display,window,gc,50,58,s,1);
	   }
	 else if (event.xkey.keycode == 10)
	   {
	     s = "1";

	     load_modmap(STANDARD_XMODMAP_FILE);
	     XDrawImageString(display,window,gc,50,58,s,1);
	   }
	break;
       case ButtonPress:
	 if ((event.xbutton.y < 48) && (event.xbutton.y > 36))
	   {
	     load_modmap(STANDARD_XMODMAP_FILE);
	     disconnect();
	     return 4 ;
	   }
	 if ((event.xbutton.y<36) && (event.xbutton.y > 24))
	   {     
	     s = "3";

	     load_modmap(GREEK_XMODMAP_FILE);
	     XDrawImageString(display,window,gc,50,58,s,1);
	   } 
	 if ((event.xbutton.y<24) && (event.xbutton.y > 12))
	   {
	     s = "2";

	     load_modmap(BOTH_XMODMAP_FILE);
	     XDrawImageString(display,window,gc,50,58,s,1);
	   }
	 if (event.xbutton.y<12) 
	   {
	     s = "1";

	     load_modmap(STANDARD_XMODMAP_FILE);
	     XDrawImageString(display,window,gc,50,58,s,1);
	   }
	 break;
       case Expose:
	 XSetBackground (display,gc,BlackPixel(display,screen));
	 XSetForeground (display,gc,WhitePixel(display,screen));
	 XDrawImageString(display,window,gc,0,10,"  1.Normal    ",12);	
	 XDrawImageString(display,window,gc,0,22,"  2.Both    ",12);	
	 XDrawImageString(display,window,gc,0,34,"  3.Greek  ",12);	 
	 XDrawImageString(display,window,gc,0,46,"<ESC>,Q.uit ",12);	 
	 XDrawImageString(display,window,gc,0,58," Mode:      ",12);
	 XDrawImageString(display,window,gc,50,58,s,1);
	 break;
       default:
	 break;
       }
    
   }

}


